#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/types.h>
#include <string.h>

#define PORT 9000
#define MESSAGE_SIZE 1024

int setup_listen_socket(int port);
int accept_connections(int sockfd);
int check_authentication(char *password, char *admin_password);

int main(int argc, char *argv[]){
//add while loop to encompass everything, then after you get a connection, fork, if fork, then do all the other stuff, if not, go back to top of loop
while(1){ //this is the outer while loop to make it run foorreeevveerrr
		FILE *password_file;
		int sock = setup_listen_socket(PORT);
		int sockfd = accept_connections(sock);
		close(sock);

	int pid = fork();
	if(pid){ //do this stuff in one thread if we get a connection

		char message[MESSAGE_SIZE];
		char uname_to_enter[50], pass_to_enter[50]; 
		char admin_password[20] = "BestPAssWorDD3vEr";
		memset(message, '\0', MESSAGE_SIZE);

		strcpy(message, "Welcome to UpdatePasswords.  Administrators can remotely update and change users and their passwords.\n\n\nPlease enter the administrator's password:\n");

		send(sockfd, message, sizeof(message), 0);
		memset(message, '\0', MESSAGE_SIZE);	

		if(read(sockfd, message, MESSAGE_SIZE) < 0){
			perror("Error reading in password: ");
			exit(0);
		}

		if(!check_authentication(message, admin_password)){
			memset(message, '\0', MESSAGE_SIZE);
			strcpy(message, "Sorry, that is the wrong password.\n");
			send(sockfd, message, sizeof(message), 0);
			close(sockfd);
			exit(0);
		} else{
			memset(message, '\0', MESSAGE_SIZE);
			strcpy(message, "Enter a username to be added/updated in the password file:\n");
			send(sockfd, message, sizeof(message), 0);
			memset(message, '\0', MESSAGE_SIZE);
			memset(uname_to_enter, '\0', 50);

			if(read(sockfd, uname_to_enter, 50) < 0){
				perror("Error reading in password: ");
				exit(0);
			}

			memset(message, '\0', MESSAGE_SIZE);
			strcpy(message, "The username you have chosen to update/add is:\n");
			send(sockfd, message, sizeof(message), 0);
			memset(message, '\0', MESSAGE_SIZE);

			char line_to_add[100];
			sprintf(line_to_add, "Admin, %s\n", admin_password);

			sprintf(message, uname_to_enter);
			send(sockfd, message, sizeof(message), 0);

			memset(message, '\0', MESSAGE_SIZE);
			strcpy(message, "\nEnter the password for the user:\n");
			send(sockfd, message, sizeof(message), 0);
			if(read(sockfd, pass_to_enter, 50) < 0){
				perror("Error reading in password: ");
				exit(0);
			}

			password_file = fopen("passwords.txt", "a+");
			fprintf(password_file, line_to_add);
			fclose(password_file);
		}

		close(sockfd);
		exit(0);
	}else{//end fork if
		close(sockfd);
	}
}//end master while
}//end main

/**
* Function to authenticate password
*
*/
int check_authentication(char *password, char *admin_password){
	char pass[16];
	int authenticated = 0;

	strcpy(pass, password);

	if(strcmp(password, admin_password) == 0){
		authenticated = 1;
	}
	return authenticated;
}

/**
 *
 * Function to setup a socket to listen
 * returns the socket file descriptor
 */
int setup_listen_socket(int port){
    int sockfd;
    struct sockaddr_in listen_addr;
    int yes=1;

    //code to set up socket
    if((sockfd = socket(PF_INET, SOCK_STREAM, 0)) == -1){
        printf("Error setting up socket.");
    }

    if(setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int)) == -1){
        printf("Error setting socket option to SO_REUSEADDR");
    }

    listen_addr.sin_family = AF_INET;
    listen_addr.sin_port = htons(port);
    listen_addr.sin_addr.s_addr = 0;
    //zero out struct
    memset(&(listen_addr.sin_zero), '\0', 8);

    if(bind(sockfd, (struct sockaddr *)&listen_addr, sizeof(struct sockaddr)) == -1){
        printf("Error binding socket");
    }

    if(listen(sockfd, 5) == -1){
        printf("Error listening on socket");
    }

    return sockfd;
}

/**
 *
 * Function to accept connections.
 * takes in the socket fd
 * returns the new fd
 */
int accept_connections(int sockfd){
    int new_sockfd;
    char *message;
    struct sockaddr_in client_addr;
    socklen_t sin_size = sizeof(struct sockaddr_in);

    if((new_sockfd = accept(sockfd, (struct sockaddr *)&client_addr, &sin_size)) == -1){
        printf("Error accepting connection");
    }

    return new_sockfd;

}
